﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ControlSharp2
{
    /// <summary>
    /// Базовый класс Родители
    /// </summary>
    public class Parents : Family
    {
        protected int year = 2024; //Текущий год
        private int birthYear;  //Год рождения
        //ФИО
        protected string surname;
        protected string name;
        protected string patronymic;

        //Свойство для указания года рождения
        protected int BirthYear
        {
            get => birthYear;
            set
            {
                if (value > 1920 && value <= 2024)
                {
                    birthYear = value;
                }
                else
                {
                    Console.ForegroundColor = ConsoleColor.Red;
                    Console.WriteLine("Вы указали неправильный год рождения!");
                    Console.ResetColor();
                    birthYear = 2024;
                }
            }
        }

        //Количество детей и количество родителей (в живых)
        protected int parents = 2; //По умолчанию 2 - (родители родителя)
        protected int children = 1; //По умолчанию 1 - (чтобы стать родителем нужен ребенок)
    
        //Конструктор заполняющий значение информации о родителе
        public Parents(int birthYear, string surname, string name, string patronymic)
        {
            BirthYear = birthYear;
            this.surname = surname;
            this.name = name;
            this.patronymic = patronymic;
        }

        //Чтобы определить возраст человека нужно вычесть из текущего года - год рождения
        public override int GetAge()
        {
            return year - birthYear;
        }

        //Фио человека состоит из 3 составляющих
        public override string GetFIO()
        {
            return surname + " " + name + " " + patronymic;
        }

        //Родители могут говорить
        public override void Speak()
        {
            Console.WriteLine("Родитель что-то говорит");
        }

        //У родителей есть дети и родители
        public override void GetLineage()
        {
            Console.WriteLine($"В наличии родителей: {parents}");
            Console.WriteLine($"В наличии детей: {children}");
        }

        //Установка значений детей и родителей
        public virtual void SetLineage()
        {
            Console.Write("Введите сколько у вас родителей: ");
            parents = Convert.ToInt32(Console.ReadLine());
            Console.Write("Введите сколько у вас детей: ");
            children = Convert.ToInt32(Console.ReadLine());
        }

    }
}
